#include <sys/time.h>
#include <time.h>
#include "Benchmark.h"

int timeval_subtract(struct timeval *result, struct timeval *x, struct timeval *y) {
     /* Perform the carry for the later subtraction by updating Y. */
     if (x->tv_usec < y->tv_usec) {
          int nsec = (y->tv_usec - x->tv_usec) / 1000000 + 1;
          y->tv_usec -= 1000000 * nsec;
          y->tv_sec += nsec;
     }
     if (x->tv_usec - y->tv_usec > 1000000) {
          int nsec = (x->tv_usec - y->tv_usec) / 1000000;
          y->tv_usec += 1000000 * nsec;
          y->tv_sec -= nsec;
     }
     
     /* Compute the time remaining to wait. `tv_usec' is certainly positive. */
     result->tv_sec = x->tv_sec - y->tv_sec;
     result->tv_usec = x->tv_usec - y->tv_usec;
     
     /* Return 1 if result is negative. */
     return x->tv_sec < y->tv_sec;
}

struct timeval Benchmark_startTime, Benchmark_stopTime, Benchmark_elapsedTime;

void tic(void) {
     gettimeofday(&Benchmark_startTime, NULL);
}

double toc(void) {
     gettimeofday(&Benchmark_stopTime, NULL);
     timeval_subtract(&Benchmark_elapsedTime, &Benchmark_stopTime, &Benchmark_startTime);
     double secondsElapsed = (double)(Benchmark_elapsedTime.tv_sec) + ((double)(Benchmark_elapsedTime.tv_usec))*1e-6;
     return(secondsElapsed);
}
