#include "plotting.h"
#include "plplot/plplot.h"
#include "plplot/plstream.h"

using namespace std;

namespace plot{
	int plot1Vec(vector<double> &x, vector<double> &y, string xlabel, string ylabel, string label) {
		if ((int) x.size() != (int) y.size()) return(-1);
	
		plstream *pls = new plstream();
		plsdev("xwin");
		pls->init();
	
		double xmin = x[0];
		double xmax = x[0];
		double ymin = y[0];
		double ymax = y[0];
		std::vector<PLFLT> X;
		std::vector<PLFLT> Y;
		X.resize((int) x.size());
		Y.resize((int) x.size());
		for (int i=0; i<(int) x.size(); i++) {
			if (x[i] < xmin) xmin = x[i];
			if (x[i] > xmax) xmax = x[i];
			if (y[i] < ymin) ymin = y[i];
			if (y[i] > ymax) ymax = y[i];
			X[i] = (PLFLT) (x[i]);
			Y[i] = (PLFLT) (y[i]);
		}
	
		pls->env((PLFLT)xmin, (PLFLT)xmax, (PLFLT)ymin, (PLFLT)ymax, 0, 0);
		pls->lab(xlabel.c_str(), ylabel.c_str(), label.c_str());
		pls->wid(2.0);
		pls->line((PLINT)X.size(),(PLFLT*)&(X[0]), (PLFLT*)&(Y[0]));
		delete pls;
		return(0);
	}

	int plot2Vec(vector<double> &x1, vector<double> &y1, vector<double> &x2, vector<double> &y2, string xlabel, string ylabel, string label) {
		if ((int) x1.size() != (int) y1.size()) return(-1);
		if ((int) x2.size() != (int) y2.size()) return(-1);
	
		plstream *pls = new plstream();
		plsdev("xwin");
		pls->init();
	
		double xmin = x1[0];
		double xmax = x1[0];
		double ymin = y1[0];
		double ymax = y1[0];
	
		std::vector<PLFLT> X1;
		std::vector<PLFLT> Y1;
		X1.resize((int) x1.size());
		Y1.resize((int) x1.size());
		for (int i=0; i<(int) x1.size(); i++) {
			if (x1[i] < xmin) xmin = x1[i];
			if (x1[i] > xmax) xmax = x1[i];
			if (y1[i] < ymin) ymin = y1[i];
			if (y1[i] > ymax) ymax = y1[i];
			X1[i] = (PLFLT) (x1[i]);
			Y1[i] = (PLFLT) (y1[i]);
		}
	
		std::vector<PLFLT> X2;
		std::vector<PLFLT> Y2;
		X2.resize((int) x2.size());
		Y2.resize((int) x2.size());
		for (int i=0; i<(int) x2.size(); i++) {
			if (x2[i] < xmin) xmin = x2[i];
			if (x2[i] > xmax) xmax = x2[i];
			if (y2[i] < ymin) ymin = y2[i];
			if (y2[i] > ymax) ymax = y2[i];
			X2[i] = (PLFLT) (x2[i]);
			Y2[i] = (PLFLT) (y2[i]);
		}
	
		pls->env((PLFLT)xmin, (PLFLT)xmax, (PLFLT)ymin, (PLFLT)ymax, 0, 0);
		pls->lab(xlabel.c_str(), ylabel.c_str(), label.c_str());
		pls->wid(2.0);
	
		pls->col0(1);
		pls->line((PLINT)X1.size(),(PLFLT*)&(X1[0]), (PLFLT*)&(Y1[0]));
		pls->col0(2);
		pls->line((PLINT)X2.size(),(PLFLT*)&(X2[0]), (PLFLT*)&(Y2[0]));
		delete pls;
		return(0);
	}
	
	int plot2Vec(vector<double> &x1, vector<double> &y1, vector<double> &x2, vector<double> &y2, string xlabel, string ylabel, string title, string legend1, string legend2) {
		if ((int) x1.size() != (int) y1.size()) return(-1);
		if ((int) x2.size() != (int) y2.size()) return(-1);
	
		plstream *pls = new plstream();
		plsdev("xwin");
		pls->init();
	
		double xmin = x1[0];
		double xmax = x1[0];
		double ymin = y1[0];
		double ymax = y1[0];
	
		std::vector<PLFLT> X1;
		std::vector<PLFLT> Y1;
		X1.resize((int) x1.size());
		Y1.resize((int) x1.size());
		for (int i=0; i<(int) x1.size(); i++) {
			if (x1[i] < xmin) xmin = x1[i];
			if (x1[i] > xmax) xmax = x1[i];
			if (y1[i] < ymin) ymin = y1[i];
			if (y1[i] > ymax) ymax = y1[i];
			X1[i] = (PLFLT) (x1[i]);
			Y1[i] = (PLFLT) (y1[i]);
		}
	
		std::vector<PLFLT> X2;
		std::vector<PLFLT> Y2;
		X2.resize((int) x2.size());
		Y2.resize((int) x2.size());
		for (int i=0; i<(int) x2.size(); i++) {
			if (x2[i] < xmin) xmin = x2[i];
			if (x2[i] > xmax) xmax = x2[i];
			if (y2[i] < ymin) ymin = y2[i];
			if (y2[i] > ymax) ymax = y2[i];
			X2[i] = (PLFLT) (x2[i]);
			Y2[i] = (PLFLT) (y2[i]);
		}
	
		pls->env((PLFLT)xmin, (PLFLT)xmax, (PLFLT)ymin, (PLFLT)ymax, 0, 0);
		
		pls->lab(xlabel.c_str(), ylabel.c_str(), title.c_str());
		pls->wid(2.0);
	
		pls->col0(1);
		pls->line((PLINT)X1.size(),(PLFLT*)&(X1[0]), (PLFLT*)&(Y1[0]));
		pls->col0(2);
		pls->line((PLINT)X2.size(),(PLFLT*)&(X2[0]), (PLFLT*)&(Y2[0]));
		
		// Draw a legend
		PLINT        nlegend = 2;
		const char   *text[2], *symbols[2];
		PLINT        opt_array[2];
		PLINT        text_colors[2];
		PLINT        line_colors[2];
		PLINT        line_styles[2];
		PLINT        line_widths[2];
		PLINT        symbol_numbers[2], symbol_colors[2];
		PLFLT        symbol_scales[2];
		PLFLT        legend_width, legend_height;
		
		// First legend entry.
		opt_array[0]   = PL_LEGEND_LINE;
		text_colors[0] = 1;
		text[0]        = legend1.c_str();
		line_colors[0] = 1;
		line_styles[0] = 1;
		line_widths[0] = 2;

		// Second legend entry.
		opt_array[1]      = PL_LEGEND_LINE;
		text_colors[1]    = 2;
		text[1]           = legend2.c_str();
		line_colors[1]    = 2;
		line_styles[1]    = 1;
		line_widths[1]    = 2;

		plscol0a( 15, 32, 32, 32, 0.70 );
		pllegend( &legend_width, &legend_height, PL_LEGEND_BACKGROUND | PL_LEGEND_BOUNDING_BOX, 0, 0.0, 0.0, 0.1, 15, 1, 1, 0, 0, nlegend, opt_array, 1.0, 1.0, 2.0, 1.,
		text_colors, (const char **) text, NULL, NULL, NULL, NULL, line_colors, line_styles, line_widths, symbol_colors, symbol_scales, symbol_numbers, (const char **) symbols );
		
		delete pls;
		return(0);
	}
}
