#pragma once
#include "opencv2/opencv.hpp"
#include <cstdint>

using namespace cv;
using namespace std;

namespace prettyPrint {
	
	//Print out a matrix nicely
	void printMat(FILE * stream, Mat& matrix, char* label) {
		fprintf(stream, "\n%s = ", label);
		if ((matrix.type() == CV_8U)  || (matrix.type() == CV_8S)  ||
		    (matrix.type() == CV_16S) || (matrix.type() == CV_32S) ||
		    (matrix.type() == CV_32F) || (matrix.type() == CV_64F)) {
			for (int x=0; x<matrix.rows; x++) {
				fprintf(stream, "\n");
				for (int y=0; y<matrix.cols; y++) {
					if (matrix.type() == CV_8U)
						fprintf(stream, "%3d  ", matrix.at<uint8_t>(x,y));
					else if (matrix.type() == CV_8S)
						fprintf(stream, "% 3d  ", matrix.at<int8_t>(x,y));
					else if (matrix.type() == CV_16S)
						fprintf(stream, "% 5d  ", matrix.at<int16_t>(x,y));
					else if (matrix.type() == CV_32S)
						fprintf(stream, "% 10d  ", matrix.at<int32_t>(x,y));
					else if (matrix.type() == CV_32F)
						fprintf(stream, "% 10F  ", matrix.at<float>(x,y));
					else //Matrix is of type double
						fprintf(stream, "% 10F  ", matrix.at<double>(x,y));
				}
			}
		}
		else
			fprintf(stream, "Unsupported Matrix Type");
	}
	
}
