#pragma once
#include "opencv2/opencv.hpp"
//#include "Feature.h"
#include "ImageStack.h"

double computeBlendedEnergy(ImageStack& Template, ImageStack& frameStack, cv::Vec2f location, const double blendingCoefficients[]);
void   computeBlendedEnergy(ImageStack& Template, ImageStack& frameStack, cv::Vec2f location, const double blendingCoefficients[], double &energy, double &Dx, double &Dy);
void   computeBlendedEnergy(ImageStack& Template, ImageStack& frameStack, ImageStack& DIDX, ImageStack& DIDY, cv::Vec2f location, const double blendingCoefficients[], double &energy, double &Dx, double &Dy);

double computeSingleFeatureEnergy(ImageStack& Template, ImageStack& frameStack, int resolutionLevel, cv::Vec2f location);
void   computeSingleFeatureEnergy(ImageStack& Template, ImageStack& frameStack, int resolutionLevel, cv::Vec2f location, double& energy, double& Dx, double& Dy);

double computeSingleFeatureEnergy_regularized(ImageStack& Template, ImageStack& frameStack, int resolutionLevel, cv::Vec2f location, cv::Vec2f locationPrior, double lambda);
void   computeSingleFeatureEnergy_regularized(ImageStack& Template, ImageStack& frameStack, int resolutionLevel, cv::Vec2f location, cv::Vec2f locationPrior, double lambda, double& energy, double& Dx, double& Dy);
