#include "opencv2/opencv.hpp"
#include <eigen3/Eigen/Eigen>
#include <iostream>
#include "Utilities.h"
#include "Benchmark.h"

using namespace cv;
using namespace std;
using namespace Eigen;

int main(int argc, char** argv) {
	
	Quaternion<double> Q(1.0, 0.0, 0.0, 0.0);
	Quaternion<double> rotationQ;
	
	rotationQ = Quaternion<double>(0.0, 0.5, 2.1, -2.5);
	Q.coeffs() += (0.5)*(0.1)*(rotationQ*Q).coeffs();
	Q.normalize();
	
	rotationQ = Quaternion<double>(0.0, -0.2, 1.1, 0.4);
	Q.coeffs() += (0.5)*(0.1)*(rotationQ*Q).coeffs();
	Q.normalize();
	
	rotationQ = Quaternion<double>(0.0, 0.0, -0.7, 1.2);
	Q.coeffs() += (0.5)*(0.1)*(rotationQ*Q).coeffs();
	Q.normalize();
	
	Matrix3d R = Q.toRotationMatrix();
	
	//printf("Q = %f + %f i + %f j + %f k\n\r\n\r",Q.w(),Q.x(),Q.y(),Q.z());
	printf("Q: % .15f + \n\r",Q.w());
	printf("   % .15f i + \n\r",Q.x());
	printf("   % .15f j + \n\r",Q.y());
	printf("   % .15f k\n\r\n\r",Q.z());
	
	/*printf("rotationQ: % .15f + \n\r",rotationQ.w());
	printf("           % .15f i + \n\r",rotationQ.x());
	printf("           % .15f j + \n\r",rotationQ.y());
	printf("           % .15f k\n\r\n\r",rotationQ.z());*/
	
	cout << R;
	printf("\n\r\n\r");
	
	/*Quaternion<double> Q1(0.3, 2.3, 0.17, -2.12);
	Quaternion<double> Q2(0.1, -1.6, 2.34, 1.53);
	Q = Q1*Q2;
	printf("Q: % .15f + \n\r",Q.w());
	printf("   % .15f i + \n\r",Q.x());
	printf("   % .15f j + \n\r",Q.y());
	printf("   % .15f k\n\r\n\r",Q.z());
	
	Q.coeffs() = Q1.coeffs() + (0.743)*Q.coeffs();
	
	Q.normalize();
	printf("Q: % .15f + \n\r",Q.w());
	printf("   % .15f i + \n\r",Q.x());
	printf("   % .15f j + \n\r",Q.y());
	printf("   % .15f k\n\r\n\r",Q.z());*/
	
}
