#!/usr/bin/python
import os
import glob

#This function goes through each recording in the folder "Recordings" and runs a plain KLT tracker
#on each with autonomous feature management. The results are saved in the respective source folders
#in the file GroundTruth.txt

recordingPaths = glob.glob("Recordings" + os.sep + "*")
recordingPaths.sort()
for i in range(len(recordingPaths)):
	recordingPaths[i] = os.path.abspath(recordingPaths[i])
for recordingPath in recordingPaths:
	recordingName = os.path.basename(recordingPath)
	targetFile = recordingPath + os.sep + "GroundTruth.txt"
	if os.path.isfile(targetFile):
		print "Skipping %s because GroundTruth.txt already exists."%(recordingName)
		print "Delete this file and re-run to generate new ground truth."
	else:
		print "Running tracker on " + recordingName
		command = "./trackPostProcess -t 0 -m 0 '" + recordingPath + "' '" + targetFile + "'"
		retvalue = os.system(command)
		if (retvalue != 0):
			print "Failed!"
			print "Command was: %s"%(command)
			print "Aborting."
			break
