#!/usr/bin/python
import os, sys, glob

#This program removes all tracker output files in all test videos. This cleans things up before running
#a fresh batch of tests and compiling results table(s)

def addTrailingSep(filePath):
	#This function ensures that the given filePath ends in a trailing
	#file separator. It returns a copy of filePath with a trailing separator
	if (filePath[len(filePath)-1] != os.sep):
		return(filePath + os.sep)
	else:
		return(filePath)

def cleanSubdirectories(baseDirectory):
	baseDirectory = addTrailingSep(baseDirectory)
	subdirs = glob.glob(baseDirectory + "*")
	for path in subdirs:
		#Clear results from each enumerated subdirectory
		if os.path.isdir(path):
			print "Clearing results from Folder: " + path + "... ",
			sys.stdout.flush()
			testVidFolder = addTrailingSep(path)
			resultsFiles     = glob.glob(testVidFolder + "Tracker_*_mode2_Results.txt")
			resultsFiles    += glob.glob(testVidFolder + "Tracker_*_TrainingResults_*.txt")
			trajectoryFiles  = glob.glob(testVidFolder + "Tracker_*_OutputTrajectories_mode1.txt")
			trajectoryFiles += glob.glob(testVidFolder + "Tracker_*_OutputTrajectories_mode2.txt")
			trajectoryFiles += glob.glob(testVidFolder + "Tracker_*_TrainingOutputTrajectories_*.txt")
			for item in resultsFiles:
				os.remove(item)
			for item in trajectoryFiles:
				os.remove(item)
			print "Done"

cleanSubdirectories("Test Videos")
cleanSubdirectories("Training Videos")

try:
	os.remove("Test Videos" + os.sep + "Mode1ResultsTable_MeanDrift.tex")
except:
	pass

try:
	os.remove("Test Videos" + os.sep + "Mode1ResultsTable_MeanL1Error.tex")
except:
	pass

try:
	os.remove("Test Videos" + os.sep + "Mode2ResultsTable.tex")
except:
	pass

try:
	os.remove("Test Videos" + os.sep + "Mode2ResultsBarGraph.tex")
except:
	pass

try:
	os.remove("Test Videos" + os.sep + "TestVidSummaryTable.tex")
except:
	pass

try:
	os.remove("Test Videos" + os.sep + "Mode2ProcessingRateTable.tex")
except:
	pass

try:
	os.remove("Training Videos" + os.sep + "TrainingResultsBarGraph_mode1.tex")
except:
	pass

try:
	os.remove("Training Videos" + os.sep + "TrainingResultsBarGraph_mode2.tex")
except:
	pass

